import * as React from 'react';
declare type Component<P> = React.Component<P> | React.ComponentType<P>;
declare type ComponentProps<C extends Component<any>> = C extends Component<infer P> ? P : never;
export interface PortalNode<C extends Component<any> = Component<any>> extends HTMLElement {
    setPortalProps(p: ComponentProps<C>): void;
    getInitialPortalProps(): ComponentProps<C>;
}
interface InPortalProps {
    node: PortalNode;
    children: React.ReactNode;
}
export declare const createPortalNode: <C extends Component<any>>() => PortalNode<C>;
export declare class InPortal extends React.Component<InPortalProps, {
    nodeProps: {};
}> {
    constructor(props: InPortalProps);
    addPropsChannel: () => void;
    componentDidMount(): void;
    componentDidUpdate(): void;
    render(): React.ReactPortal;
}
declare type OutPortalProps<C extends Component<any>> = {
    node: PortalNode;
} & Partial<ComponentProps<C>>;
export declare class OutPortal<C extends Component<any>> extends React.Component<OutPortalProps<C>> {
    private placeholderNode;
    constructor(props: OutPortalProps<C>);
    passPropsThroughPortal(): void;
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
}
export {};
